#import "EncryptblowfishPlugin.h"
#import <Foundation/Foundation.h>
#import <CommonCrypto/CommonCryptor.h>


@implementation EncryptblowfishPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"encryptblowfish"
            binaryMessenger:[registrar messenger]];
  EncryptblowfishPlugin* instance = [[EncryptblowfishPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS" stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  } else if([@"getStringAfterEncrypt" isEqualToString:call.method]) {
    //NSData* dataOrigin = call.arguments[@"origin"];
    //NSString* strOrigin = [[NSString alloc] initWithData:dataOrigin encoding:NSUTF8StringEncoding];
    NSString* strOrigin = call.arguments[@"origin"];

    //NSData* dataKey = call.arguments[@"key"];
    NSString* key = call.arguments[@"key"];
    //NSString* key = [[NSString alloc] initWithData:dataKey encoding:NSUTF8StringEncoding] ;
    NSError *error;
    NSData *IV  =  nil;

    NSData *dataOriginal = [strOrigin dataUsingEncoding:NSUTF8StringEncoding];
    NSData *dataKey = [key dataUsingEncoding:NSUTF8StringEncoding];
    // Encryption
    NSData *dataEncrypted = [self doBlowfish:dataOriginal
                                             context:kCCEncrypt
                                                 key:dataKey
                                             options:kCCModeECB | kCCOptionECBMode
                                                  iv:IV
                                               error:&error];
    NSString *encryptedBase64String = [dataEncrypted base64EncodedStringWithOptions:0];

    if(error){
        NSLog(@"Error : %@" , error.localizedDescription);
    }else{
        NSLog(@"string: %@", encryptedBase64String);
    }

    //result(encryptedBase64String);
    result([@"" stringByAppendingString:encryptedBase64String]);
  }else if([@"getStringAfterDecrypt" isEqualToString:call.method]) {
      NSData *IV  =  nil;
      //NSData* dataDecrypt = call.arguments[@"decrypt"];
      //NSString* strDecrypt = [[NSString alloc] initWithData:dataDecrypt encoding:NSUTF8StringEncoding];
      NSString* strDecrypt = call.arguments[@"decrypt"];

      //NSData* dataKey = call.arguments[@"key"];
      //NSString* key = [[NSString alloc] initWithData:dataKey encoding:NSUTF8StringEncoding] ;
      NSString* key = call.arguments[@"key"];

      NSError *error;

      NSData *dataKey = [key dataUsingEncoding:NSUTF8StringEncoding];
      NSData *dataToDecrypt = [[NSData alloc] initWithBase64EncodedString:strDecrypt options:0];

      NSData *dataDecrypted = [self doBlowfish:dataToDecrypt
                                                 context:kCCDecrypt
                                                     key:dataKey
                                                 options:kCCOptionECBMode
                                                      iv:IV
                                                   error:&error];

      NSString *stringDecrypted = [[NSString alloc] initWithData:dataDecrypted encoding:NSUTF8StringEncoding];
    //result(stringDecrypted);
    result([@"" stringByAppendingString:stringDecrypted]);
  } else {
    result(FlutterMethodNotImplemented);
  }
}


// Blowfish Encryption and Decryption
- (NSData *)doBlowfish:(NSData *)dataIn
               context:(CCOperation)kCCEncrypt_or_kCCDecrypt
                   key:(NSData *)key
               options:(CCOptions)options
                    iv:(NSData *)iv
                 error:(NSError **)error
{
    CCCryptorStatus ccStatus   = kCCSuccess;
    size_t          cryptBytes = 0;
    NSMutableData  *dataOut    = [NSMutableData dataWithLength:dataIn.length + kCCBlockSizeBlowfish];

    ccStatus = CCCrypt( kCCEncrypt_or_kCCDecrypt,
                       kCCAlgorithmBlowfish,
                       options,
                       key.bytes,
                       key.length,
                       iv.bytes,
                       dataIn.bytes,
                       dataIn.length,
                       dataOut.mutableBytes,
                       dataOut.length,
                       &cryptBytes);

    if (ccStatus == kCCSuccess) {
        dataOut.length = cryptBytes;
    }
    else {
        if (error) {
            *error = [NSError errorWithDomain:@"kEncryptionError"
                                         code:ccStatus
                                     userInfo:nil];
        }
        dataOut = nil;
    }
    return dataOut;
}
@end
